
/*
Copyright 2007 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of prefswitch.

Prefswitch is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Prefswitch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with prefswitch; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function State(id, name, description, tooltip, color)
{
	this.id = null;
	this.name = null;
	this.description = null;
	this.tooltip = null;
	this.color = null;
	this.preferences = [];

	this.setID = function(value)
	{
		if(value && value != "") this.id = "" + value;
		else this.id = this.generateID();
	};

	this.setName = function(value)
	{
		this.name = value;
	};

	this.setDescription = function(value)
	{
		this.description = value;
	};

	this.setTooltip = function(value)
	{
		this.tooltip = value;
	};

	this.setColor = function(value)
	{
		this.color = value;
	};

	this.setPreference = function(i, preference)
	{
		this.preferences[i] = preference;
	};

	this.setPreferences = function(value)
	{
		this.preferences = value;
	};

	this.getID = function()
	{
		return this.id;
	};

	this.getName = function()
	{
		return this.name;
	};

	this.getDescription = function()
	{
		return this.description;
	};

	this.getTooltip = function()
	{
		return this.tooltip;
	};

	this.getColor = function()
	{
		return this.color;
	};

	this.getPreference = function(i)
	{
		return this.preferences[i];
	};

	this.getPreferences = function()
	{
		return this.preferences;
	};

	this.getPreferencesArray = function()
	{
		var aPreferences = [];
		for(var i=0; i<this.preferences.length; i++)
		{
			var preference = this.getPreference(i);
			aPreferences[aPreferences.length] = [preference.getName(), preference.getType(), preference.getValue(), preference.getDescription()];
		}
		return aPreferences;
	};

	this.addPreference = function(preference)
	{
		this.preferences[this.preferences.length] = preference;
	};

	this.removePreference = function(index)
	{
		var tmpStates = [];
		for(var i=0, j=0; i<this.preferences.length; i++)
			if(i != index) tmpStates[j++] = this.preferences[i];
		this.preferences = tmpStates;
	};

	this.generateID = function()
	{
		var date = new Date();
		return "" + date.getTime();
	};

	this.setID(id);
	this.setName(name);
	this.setDescription(description);
	this.setTooltip(tooltip);
	this.setColor(color);
}
